# SourcePath: openssh/20191126dev
Summary: OpenSSH Secure Shell (ssh) client and server
Name: sony-target-dev-openssh
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-openssh
Version: 7.9p1
Release: 12000002
URL: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable
Source: openssh-%{version}.tar.gz
Patch1: openssh-7.9p1-Makefile.patch
Patch2: openssh-7.9p1-CVE-2018-20685.patch
Patch3: openssh-7.9p1-CVE-2019-6109.patch
Patch4: openssh-7.9p1-CVE-2019-6109-2.patch
Patch5: openssh-7.9p1-CVE-2019-6111.patch
Patch6: openssh-7.9p1-CVE-2019-6111-2.patch
License: BSD
Group: %{sony_group}
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_target_dir}

# OpenSSH privilege separation requires a user & group ID
%define sshd_uid    74
%define sshd_gid    74

%description
This is the portable version of OpenSSH, a free implementation of
the Secure Shell protocol as specified by the IETF secsh working
group. 

%package -n %{pkgname}
Summary: OpenSSH Secure Shell (ssh)  
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
SSH (Secure SHell) is a program for logging into and executing
commands on a remote machine. SSH is intended to replace rlogin and
rsh, and to provide secure encrypted communications between two
untrusted hosts over an insecure network. X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

This package includes the core files necessary for both the OpenSSH
client and server. To make this package useful, you should also
install openssh-clients, openssh-server, or both.

This package contains files need to run an ssh client (ssh, scp)

This packages contains files needed to run an ssh server


%prep
%setup -q -n openssh-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%build
%sony_target_dev_setup

export ac_cv_func_getpgrp_void=yes
export ac_cv_file___dev_ptc_=no
export ac_cv_file___dev_urandom_=yes
export ac_cv_have_accrights_in_msghdr=no
export ac_cv_have_control_in_msghdr=yes
export enable_etc_default_login=no
export ac_cv_search_ECDSA_SIG_get0='none required'
export ac_cv_search_ECDSA_SIG_set0='none required'

%sony_target_dev_configure \
	--with-tcp-wrappers --sysconfdir=%{sony_target_dev_sysconf_dir}/ssh \
	--libexecdir=%{sony_target_dev_libexec_dir}/openssh \
	--with-rsh=%{sony_target_dev_bin_dir}/rsh \
	--without-zlib-version-check \
	--disable-strip \
	--includedir=%{sony_target_dev_include_dir} \
	--with-md5-passwords --with-pam --with-ipv4-default \
	--with-privsep-path=/var/run/sshd
make CFLAGS='-O2 -DBROKEN_CMSG_TYPE  -std=gnu99  -Wall -fPIC -DLOGIN_PROGRAM=\"/devel/bin/login\" -DSSHD_PAM_SERVICE=\"ssh\" -D__FILE_OFFSET_BITS=64'

%install
rm -rf %{buildroot}
%sony_target_dev_setup
%sony_target_dev_makeinstall

mkdir -p -m755 %{buildroot}%{sony_target_dir}/var/run/sshd

install -d %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/pam.d/
install -p -m 755 ../contrib/redhat/sshd.pam %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/pam.d/sshd

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/default
echo "# Set AUTOKEYGEN=yes to make the ssh init script autogenerate" \
	> %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/default/ssh
echo "# the required keys if they are not on the system." \
	>> %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/default/ssh
echo "AUTOKEYGEN=no" \
	>> %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/default/ssh
cd
rm -rf  %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}
rm -rf  %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/man

%clean
rm -rf %{buildroot}


%files -n %{pkgname}
%defattr(-,root,root)
%{sony_target_dir}%{sony_target_dev_bin_dir}/ssh
%{sony_target_dir}%{sony_target_dev_bin_dir}/ssh-agent
%{sony_target_dir}%{sony_target_dev_bin_dir}/ssh-add
%{sony_target_dir}%{sony_target_dev_bin_dir}/scp
#%{sony_target_dir}%{sony_target_dev_bin_dir}/slogin
%{sony_target_dir}%{sony_target_dev_bin_dir}/sftp
%{sony_target_dir}%{sony_target_dev_bin_dir}/ssh-keygen
%{sony_target_dir}%{sony_target_dev_bin_dir}/ssh-keyscan
%{sony_target_dir}%{sony_target_dev_sbin_dir}/sshd
#%{sony_target_dir}%{sony_target_dev_sharedstate_dir}/Ssh.bin
%{sony_target_dir}%{sony_target_dev_libexec_dir}/openssh/sftp-server
%{sony_target_dir}%{sony_target_dev_libexec_dir}/openssh/ssh-keysign
%{sony_target_dir}%{sony_target_dev_sysconf_dir}/pam.d/sshd
%dir %{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssh
%config(noreplace) %{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssh/ssh_config
%config(noreplace) %{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssh/sshd_config
%config(noreplace) %{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssh/moduli
%config %{sony_target_dir}%{sony_target_dev_sysconf_dir}/default/ssh
%dir %{sony_target_dir}/var/run/sshd

%{sony_target_dir}%{sony_target_dev_libexec_dir}/openssh/ssh-pkcs11-helper

%changelog
* Tue Nov 26 2019 Sony Corporation
- Added Security fix for CVE-2018-20685, CVE-2019-6109, CVE-2019-6111.

* Mon Jul 29 2019 Sony Corporation
- Version up for openssl-1.1.1a dependency.

* Wed Jan 18 2016 Sony Corporation
- Version update to 7.4p1.

* Fri Mar 29 2013 Sony Corporation
- Version update to 6.1p1.

* Thu Apr 23 2009 Sony Corporation
- version up to 5.2p1

* Mon May 29 2006 Sony Corporation
- Initial build
